Attribute VB_Name = "IconExtractor"
'Special for using variables without formally declaring them...
Option Explicit
'For extracting the icon info from a file...
Public Declare Function ExtractIcon Lib "shell32.dll" Alias "ExtractIconA" (ByVal hInst As Long, ByVal lpszExeFileName As String, ByVal nIconIndex As Long) As Long
'For removing (closing) the icon from access with the program...
Public Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long
'For drawing the icon into the picture box...
Public Declare Function DrawIconEx Lib "user32" (ByVal hDC As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
'Also for drawing icons in to the picture box...
Public Declare Function DrawIcon Lib "user32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal hIcon As Long) As Long
'A flag for running the DrawIconEx API normally without any options...
Private Const DI_NORMAL = &H3

Public Sub DecorateThumbs(Index As Integer, Optional ThumbPath As String)
'This sub adds the picture to the buttons and makes the pictures proportional...
'Declare variables...
Dim Holder, Ratio, NewHeight, NewWidth, ThePath, TheName, IconList, Directory
'Using Form1 (meaning that when we put a '.' it means that it is really 'Form1.')...
With Form1
'Clear the Icon box...
.IconShower.Cls
'Make the filename equal the complete filename using the folder and the file list
'view...
TheName = .Folders & "\" & .Files
'Count the icons and put the amount in a variable...
IconList = ExtractIcon(0, TheName, .IconSelect.ListIndex)
'Put the icon into the picture box using the DrawIcon API...
DrawIcon .IconShower.hDC, 0, 0, IconList
'Set the picture...
.Thumbnail(Index).Picture = .IconShower.Image
'Make it's tag equal the name...
.Thumbnail(Index).Tag = TheName
'Make it enabled...
.Thumbnail(Index).Enabled = True
'End the With statement...
End With
End Sub

Public Function KillThumbNails()
'This sub deletes all thumbnails...
'Declare variables...
Dim Processor
'Skip errors...
On Error Resume Next
'Using form 1 as the identifier...
With Form1
'If there are no thumbnails, just exit...
If .Thumbnail.Count <= 1 Then Exit Function
'Make Processor equal the list of thumbnails...
For Processor = 0 To .Thumbnail.Count - 1
    'Make the thumbnail invisible...
    .Thumbnail(Processor).Visible = False
    'Restore the picture box height...
    .Scene.Height = 5865
    'Remove the picture...
    .Thumbnail(Processor).Picture = LoadPicture("")
    'Remove the tag...
    .Thumbnail(Processor).Tag = ""
    'Remove any identification of ap icture...
    Set .Thumbnail(Processor).Picture = Nothing
    'Unload the button...
    Unload .Thumbnail(Processor)
'Do this for all buttons...
Next Processor
'Stop form 1 as the identifier...
End With
End Function
